<template src="./editInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';
    import DatePickerComponent from '../../../../../inputs/DatePickerComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('select-component', SelectComponent);
    Vue.component('datepicker-component', DatePickerComponent);

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseUserStoreObject());
        },

        data() {

            return {

                baseInfo: {

                    name: '',

                    role_id: null,

                    email: '',

                    dob: '',

                    company_name: '',

                    phone_number: ''
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * After user is loaded.
             */
            parseUserStoreObject() {

                let user                    = this.$store.state.user;
                this.baseInfo.name          = user.name;
                this.baseInfo.role_id       = user.role_id.toString();
                this.baseInfo.email         = user.email;
                this.baseInfo.dob           = user.dob;
                this.baseInfo.company_name  = user.company_name;
                this.baseInfo.phone_number  = user.phone_number;
            }
        },

        computed: {

            /**
             * Data for roles select from store getter.
             **/
            selectRolesList() {

                return this.$store.getters.selectRoles;
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setUser', newBaseInfo);
                },

                deep: true
            }
        }
    }

</script>